// Copyright (2013) Jann Horn <jann@thejh.net>

HEADER #include <stdio.h>
HEADER #include <sys/types.h>
HEADER #include <dirent.h>

#include <errno.h>

// nonzero iterator exit code means cancel
HEADER typedef int dir_iterator(struct dirent *dent, void *data);
PUBLIC_FN int fdir_foreach(DIR *d, dir_iterator *iter, void *data) {
  struct dirent de;
  struct dirent *res;
  while (1) {
    int rd_res = readdir_r(d, &de, &res);
    if (rd_res) return rd_res;
    if (res == NULL) return 0;
    int iter_res = iter(&de, data);
    if (iter_res) return iter_res;
  }
}

PUBLIC_FN int dir_foreach(char *path, dir_iterator *iter, void *data) {
  DIR *d = opendir(path);
  if (d == NULL) return 1;
  int feach_res = fdir_foreach(d, iter, data);
  int errno_ = errno;
  closedir(d);
  errno = errno_;
  return feach_res;
}

HEADER // requires stdio.h
HEADER #define FDIR_FOREACH(dir, element_name, code) {                                                     \
HEADER   struct dirent element_name;                                                                       \
HEADER   struct dirent *__jh_fdir_foreach_res;                                                             \
HEADER   while (1) {                                                                                       \
HEADER     int __jh_fdir_foreach_rd_res = readdir_r(dir, &element_name, &__jh_fdir_foreach_res);           \
HEADER     if(__jh_fdir_foreach_rd_res) {*(char*)0 = 0; /*crash, boom – EBADF happened (probably)*/}       \
HEADER     if (__jh_fdir_foreach_res == NULL) goto end;                                                    \
HEADER     {code}                                                                                          \
HEADER   }                                                                                                 \
HEADER   end:;                                                                                             \
HEADER }